#!/bin/bash
. /etc/kona/soundsystem.inc
touch /etc/kona/initdesktop
trace initdesktop-in
#sleep 5
if [ ! -z "$(grep 7.0/ /etc/kona/os-release)" ]; then
  if [ -z "$(pgrep syndaemon)" ]; then
    if [ -f /etc/kona/waitime ]; then
      if [ "$(cat /etc/kona/waitime)" != "0" ]; then
        syndaemon -i $(cat /etc/kona/waitime) -K -R &
      fi
    fi
  fi
fi

if [ -d /run/live ]; then
  [ -z "$(pgrep light-locker)" ] || killall light-locker
  [ -z "$(pgrep xscreensaver)" ] || killall xscreensaver
  [ -z "$(pgrep -f  mate-screensaver)" ] || killall mate-screensaver
  [ -z "$(pgrep -f cinnamon-screensaver)" ] || killall cinnamon-screensaver

  cp /etc/skel/Desktop/install-debian.desktop ~/Desktop
#  sleep 10
#  if [ -z "$(ip route)" ]; then
#    zenity --warning --title="インストールの注意点" --text="インストールを開始する前にネットワークに接続してください" --no-wrap
#  fi
  /etc/kona/checkpolkit.sh
#  /etc/kona/pmcheck.sh
  /etc/kona/autoupdatecheck.sh
  rm -f /etc/kona/initdesktop
  trace initdesktop-exit
  exit
else
  rm -f ~/Desktop/install-debian.desktop
  rm -f ~/.local/share/plasma_icons/install-debian.desktop
fi

#sleep 20

trace initdesktop-1

notify-send "システムの状態をチェックします" -i system-software-update

if [ "$(whoami)" = "root" ]; then
  zenity --warning --text="Rootでログインは禁止しています" --no-wrap
  rm -f /etc/kona/initdesktop
  systemctl reboot
fi

trace initdesktop-2
/etc/kona/checksystem.sh

trace initdesktop-3
/etc/kona/wmcheck.sh

trace initdesktop-4
cd ~
rm -f connecting
wget -q --timeout=30 "http://simosnet.com/debian/packages/connecting"
if [ ! -f connecting ]; then
  trace initdesktop-4-1
  sleep 30
  trace initdesktop-4-2
  if [ -z "$(pgrep NetworkManager)" ]; then
    gksudo "systemctl start NetworkManager.service"
    sleep 10
    trace initdesktop-4-3
  fi
  wget -q --timeout=30 "http://simosnet.com/debian/packages/connecting"
  trace initdesktop-4-4
  if [ ! -f connecting ]; then
#    if [ -f /etc/kona/verbose ]; then
      if [ -z "$(ip route)" ]; then
	zenity --warning --title="ネットワーク未接続" --text="ネットワークに接続していないようですが\nこのままでは重要なエディションの更新(注)やシステムのアップデートができません。\nネットワークには常に接続できる状態にしてください。\nまたシステムのアップデートを保留したり手動で行うのは修正が遅れるので感心しません。\nオフラインで使うことには賛成できません。\nイレギュラーな使い方はできるだけ避けシステムに準備されている機能にまかせてください。\n(注)バグの修正、音質改善など" --no-wrap
#        if [ -f /etc/kona/debug ]; then
#          /etc/kona/getneterrorinfo.sh
#        fi
      else
	zenity --warning --title="サーバー接続不可" --text="Kona Linuxのサーバー(simosnet.com)に接続できません\nシステムは使用できますが重要なエディションの更新はできまないことに注意してください。\nサーバーの接続は少し時間をおいてから再試行してください" --no-wrap
      fi
#    fi
    /etc/kona/autoupdatecheck.sh
    rm -f /etc/kona/initdesktop
    exit
  fi
fi 
#if [ -f /etc/kona/network-error-info.log ]; then
#  mv /etc/kona/network-error-info.log /etc/kona/network-error-info.log.old
#fi
rm connecting

#notify-send "システムの状態をチェックします" -i system-software-update
trace "get update file"
version="$(cat /etc/kona/version)"
updfile="update-$version.tgz"
rm -f "$updfile"
wget -q --timeout=30 http://simosnet.com/debian/packages/Konalinux/debian/update/7.0/"$updfile"
trace "update file is getted and verify start"
/etc/kona/verifyupdate.sh $updfile
trace "verify end"
if [ "$?" = "0" ]; then
  if [ -f /etc/kona/update/update.tgz ]; then
    if [ ! -z "$(diff "$updfile" /etc/kona/update/update.tgz)" ]; then
      mv "$updfile" /etc/kona/update
      if [ ! -f /etc/kona/update/update-desktop.sh ]; then
	if [ -f /etc/kona/verbose ]; then
          notify-send "自動更新の準備ができました。" -i system-software-update
#        if [ ! -z "$(ps xa|grep sshd:|grep -v grep)" ]; then
#          wall "自動更新の準備ができました。"
#          wall "システムを再起動して最新にしてください。"
#        fi
        fi
      fi
    else
      rm -f "$updfile"
      if [ -f /etc/kona/autoupdated ] && [ ! -x /etc/kona/update/update-desktop.sh ]; then
#	rm -f /etc/kona/autoupdated
	if [ -f /etc/kona/verbose ]; then
          notify-send "自動更新をかけました。" -i system-software-update
#        if [ ! -z "$(ps xa|grep sshd:|grep -v grep)" ]; then
#          wall "自動更新をかけました。"
#        fi
        fi
      fi
    fi
  else
    mv "$updfile" /etc/kona/update
    if [ ! -f /etc/kona/update/update-desktop.sh ]; then
      if [ -f /etc/kona/verbose ]; then
        notify-send "自動更新の準備ができました。" -i system-software-update
#      if [ ! -z "$(ps xa|grep sshd:|grep -v grep)" ]; then
#        wall "自動更新の準備ができました。"
#      fi
      fi
    fi
  fi
fi
rm -f "$updfile"
trace "upate file get end"

if [ -f /etc/kona/pkgadd ] && [ ! -f /etc/kona/update/update-* ] && ! dpkg -l|grep -q konalinux-7.0 ; then
  if [ ! -z "$(apt-cache search konalinux-7.0)" ]; then
    gksudo "apt-get -y --force-yes install konalinux-7.0"
  fi
fi

if [ -x /etc/kona/update/update-desktop.sh ]; then
  notify-send "インストールの準備をしています" "インストールが終わるまでシステムを落とさないてください" -i system-software-update
  gksudo /etc/kona/update/update-desktop.sh
  notify-send "インストールが終わりました" "システムを再起動してください" -i system-software-update
  if [ -f /etc/kona/autoupdated ] && [ ! -f /etc/kona/update/update-* ]; then
#     rm -f /etc/kona/autoupdated
     if [ -f /etc/kona/verbose ]; then
       notify-send "自動更新をかけました。" -i system-software-update
     fi
  fi
fi

if grep -q x86_64 /etc/kona/os-release ; then
  arc="64"
else
  arc="32"
fi
trace "check system status"
if [ ! -f /etc/kona/update/update-* ]; then
  if [ -f /etc/kona/pkgadd ]; then
#    notify-send "システムの状態をチェックします" -i system-software-update
    rm -f /etc/kona/latestsystem
    if [ -z "$(ps xa|grep -v grep|grep update-notifier.sh)" ]; then
      trace "call update-notifier.sh"
      /etc/kona/update-notifier.sh
    fi
    if [ -f /etc/kona/latestsystem ]; then
      if [ ! -f /etc/kona/autoupdated ] || [ ! -f /etc/kona/update/update-$version.tgz ]; then
        notify-send "システムは最新状態です" -i system-software-update
      fi
    fi
    rm -f /etc/kona/autoupdated
  fi
fi

rm -f /etc/kona/update/update-desktop.sh
trace "call dfc1"
dfc1
if [ -f /etc/kona/pkgadd ]; then
#  /etc/kona/localize_pm.sh
  trace "autoupdatechek call"
  /etc/kona/autoupdatecheck.sh
  /etc/kona/checkaudio.sh
  if [ ! -f /etc/kona/firstsoundset ] && [ ! -f /etc/kona/update/update-desktop.sh ]; then
    zenity --info --title="サウンドの設定" --text="設定ー[サウンドの設定]でサウンドおよびサービスの起動を設定することができます\nサウンドの設定はデフォルトで最適な状態になっていますがそれにあきたらないときは変更できます\nしかし変更による音の変化は微妙で組み合わせは複雑なため試行錯誤が必要です" --no-wrap
    /etc/kona/soundset.sh
    touch /etc/kona/firstsoundset
  fi
#  if [ ! -f /etc/kona/aboutsystem ]; then
#    touch /etc/kona/aboutsystem
#    if [ /usr/bin/firefox ]; then
#      firefox https://docs.google.com/document/d/13I-2dugfre_9Ace5y_yumRgJhx2n8Vm_e1rJkK-A0nQ/edit
#    elif [ /usr/bin/palemoon ]; then
#      palemoon https://docs.google.com/document/d/13I-2dugfre_9Ace5y_yumRgJhx2n8Vm_e1rJkK-A0nQ/edit
#    fi
#  fi
  rm -f /etc/kona/initdesktop
  trace initdesktop-out-1
  exit
fi

if [ "$LANG" = "ja_JP.UTF-8" ] || [ "$LANG" = "ja_JP.utf8" ]; then
zenity --title="パッケージ追加" --question --text="パッケージ追加" --question --text="有用なパッケージ(*)を追加します\nこれが終わるまではインストールは完了しません\nまたシステムのアップデートはこれが終わってからにしてください\n続けますか?\n\n(*)ビデオコーデック, vlc, clementine, chrome-browser,...など" --no-wrap
else
zenity --title="Additional packages" --question --text="I will add a useful packages.\nSome time it may take.\nDo yo want to continue?"
fi
case $? in
 0) ;;
 1) rm -f /etc/kona/initdesktop 
    exit;;
 255) rm -f /ec/kona/initdesktop
      exit;;
esac
wget -q http://simosnet.com/debian/packages/Konalinux/debian/7.0/pkgadd${arc}.sh
mv pkgadd${arc}.sh /etc/kona/pkgadd.sh
chmod +x /etc/kona/pkgadd.sh
gksudo "xterm -e /etc/kona/pkgadd.sh"

if [ -f /etc/kona/pkgadd ]; then
  /etc/kona/docky.sh
  if [ "$LANG" = "ja_JP.UTF-8" ] || [ "$LANG" = "ja_JP.utf8" ]; then
    zenity --title="パッケージ追加" --warning --text="おめでとうございます\nインストールが終了しました\nシステムを再起動して完了してください\n\n【Kona Linux ファミリーのご紹介】\nKona Linuxにはデスクトップが\nMate, Xfce, Cinnamon, GNOME, KDEの\n各デスクトップ版があります\nぜひ一度お試しください" --no-wrap
  else
    zenity --title="Packges is added" --warning --text="Congratulations!\nInstallation is completely finished"
  fi
fi
rm -f /etc/kona/initdesktop

trace initdesktop-out

