#!/bin/bash
kernels="rt!xenomai4!kona!liquorix!pf!xanmod"
module="kona"
if [ -z "$(grep avx /proc/cpuinfo)" ]; then
  zenity --warning --title="高音質カーネルインストーラー" --text="このCPUにはインストールできません" --no-wrap
  exit
fi
ret=$(yad --form --center --no-wrap --title="高速カーネルインストーラー" --image="/usr/share/icons/Adwaita/32x32/emblems/emblem-system-symbolic.symbolic.png" --text="Kona Linux用高音質カーネルをインストールする\n\n rt ... リアルタイムカーネル\n xenomai4 ... Xenomai4カーネル\n kona ... Konaカーネル\n pf ... Pfカーネル\n liquorix ... Zenカーネル\n xanmod ... Xanmodカーネル\n\nプリセットは'デフォルト'がおすすめ\n"  --field="カーネル:CB" "$module!$kernels")
if [ "$?" = "0" ]; then
  kernelname="$(echo $ret|cut -d'|' -f1)"
  if [ "$kernelname" = "xenomai3" ]; then
    kernel="linux-image-5.4.239-xenomai-kona"
  elif [ "$kernelname" = "xenomai4" ]; then
    kernel="linux-image-6.5.0-xenomai4-kona"
  elif [ "$kernelname" = "kona" ]; then
    kernel="linux-image-6.1.67-kona"
  elif [ "$kernelname" = "xanmod" ]; then
    kernel="linux-image-6.5.13-kona-xanmod1"
  elif [ "$kernelname" = "pf" ]; then
    kernel="linux-image-6.4.0-pf3-pf-kona"
  elif [ "$kernelname" = "rt" ]; then
    kernel="linux-image-6.1.37-rt13-rc1-kona"
  elif [ "$kernelname" = "liquorix" ]; then
    kernel="linux-image-6.4.3-lqx1-kona"
  fi
  [ -z "$kernel" ] && exit
  if [  ! -z "$(dpkg -l|grep "ii  $kernel")" ]; then
    cver="$(dpkg -l|grep "ii  $kernel"|awk '{print $3}')"
    nver="$(apt-cache policy $kernel|grep 候補|awk '{print $2}')"
    if [ -z "$version" ] && [ "$cver" = "$nver" ]; then
      zenity --warning --title="高音質カーネルインストーラー" --text="$kernelnameカーネルはすでに最新です" --no-wrap
      exit
    fi
  fi
  if [ ! -z "$version" ]; then
    echo "$kernel=$version" > /etc/kona/kernel
  else
    echo $kernel > /etc/kona/kernel
  fi
  pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY xterm -e /etc/kona/installxanmod2.sh
  if [ ! -z "$(dpkg -l|grep "ii  $kernel")" ]; then
    kver="$(echo $kernel|cut -b13-)"
    if [ -f /etc/kona/soundrivers/$kver/snd.ko.tgz ]; then
      rm -fr /etc/kona/soundrivers/$kver
    fi
    zenity --info --title="高音質カーネルインストール" --text="$kernelnameカーネルをインストールしました" --no-wrap
  fi
fi
