#!/bin/bash
kernels="linux-xanmod-x64v4!linux-xanmod-x64v3!linux-xanmod-x64v2!linux-xanmod-x64v1"
if [ ! -z "$(lscpu|grep avx)" ]; then
  if [ ! -z "$(lscpu|grep avx2)" ]; then
    module="linux-xanmod-x64v4"
    condition="\n自動判定:AVX2命令を実行できる最新CPU→v4\n"
  else
    module="linux-xanmod-x64v2"
    condition="\n自動判定:AVX命令を実行できる新しいCPU→v3 or v2\n"
  fi
else
  module="linux-xanmod-x64v2"
  condition=""
fi
ret=$(yad --form --center --no-wrap --title="Xanmod/Xenomaiカーネルインストーラー" --image="/usr/share/icons/Adwaita/32x32/emblems/emblem-system-symbolic.symbolic.png" --text="XanmodカーネルはインストールするCPUの種類によって\n適合するv1,v2,v3,v4を選択する必要があります\n詳しくはhttps://xanmod.orgを参照\n$condition" --field="カーネル:CB" "$module!$kernels")
if [ "$?" = "0" ]; then
  kernel="$(echo $ret|cut -d'|' -f1)"
  echo $kernel
  if [ ! -z "$(dpkg -l|grep "ii  $kernel")" ]; then
    zenity --warning --title="Xanmod/Xenomaiカーネル" --text="$kernelはすでにインストールされています" --no-wrap
  else
    echo $kernel > /etc/kona/kernel
    pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY xterm -e /etc/kona/installxanmod2.sh
    if [ ! -z "$(dpkg -l|grep "ii  $kernel")" ]; then
      zenity --info --title="Xanmod/Xenomaiカーネルインストール" --text="$kernelをインストールしました" --no-wrap
    fi
  fi
fi
