#!/bin/bash
  s1="FALSE"
  s2="FALSE"
  s3="FALSE"
  if [ -f /etc/kona/preset ]; then
    if [ "$(cat /etc/kona/preset)" = "デフォルト" ]; then
      s1="TRUE"
    elif [ "$(cat /etc/kona/preset)" = "ダイレクト" ] || [ "$(cat /etc/kona/preset)" = "ダイレクトハイブリッド" ]; then
      s2="TRUE"
    elif [ "$(cat /etc/kona/preset)" = "高音質" ] || [ "$(cat /etc/kona/preset)" = "高音質ハイブリッド" ]; then
      s3="TRUE"
    fi
  fi
  ret=$(zenity --list --width="550" --height="200" --title="プリセットの設定" --text="最適なプリセットを設定します\nあなたが好むサウンドを選択してください" --radiolist --column="選択" --column="サウンド" --column="説明" --column="プリセット" "$s1" "癒やしサウンド" "Konaサウンド(おすすめ)" "デフォルト" "$s2" "クリアサウンド"  "すっきり/はっきりした音質" "ダイレクト" "$s3" "高音質サウンド" "最高の音質" "高音質") 
  if [ "$?" = "0" ]; then
    if [ -z "$ret" ]; then
      zenity --warning --title="プリセットの設定" --text="ユーザーを選択してください" --no-wrap
      exit
    fi
    if [ "$ret" = "癒やしサウンド" ] && [ "$s1" = "FALSE" ]; then
      preset="デフォルト"
    elif [ "$ret" = "クリアサウンド" ]; then
      preset="ダイレクト"
      if [ ! -z "$(lsmod|grep ^snd_usb_audio)" ]; then
        preset="ダイレクトハイブリッド"
      fi
    elif [ "$ret" = "高音質サウンド" ]; then
      preset="高音質"
      if [ ! -z "$(lsmod|grep ^snd_usb_audio)" ]; then
        preset="高音質ハイブリッド"
      fi
    fi  
    if [ ! -z "$preset" ] && [ "$(cat /etc/kona/preset)" != "$preset" ]; then
      echo "$preset" > /etc/kona/preset
      touch /etc/kona/preset2
      zenity --warning --title="プリセットの設定" --text="サウンド設定のダイアログが開くの必ずOKを押して終了してください\n\nボタンが画面からはみ出て押せないときは\nalterキーを押しながらダイアログの任意の場所をドラッグすると\nウィンドウを移動させることができます" --no-wrap
      /etc/kona/soundset.sh
      rm /etc/kona/preset2
    else
      preset="$(cat /etc/kona/preset)"
      zenity --warning --title="プリセットの設定" --text="プリセットはすでに$presetに設定されています" --no-wrap
    fi
  fi

