#!/bin/bash
. /etc/kona/soundsystem.inc
if [ -f /etc/kona/restartserver ]; then
  exit
fi
trace startserver-in
if [ "$(cat /etc/kona/soundsystem)" = "jack" ] && [ -f /etc/kona/headless ]; then
  /etc/kona/jackstart
  trace startserver-out-jack
  exit
fi

if [ "$(cat /etc/kona/soundsystem)" = "pulse" ]; then
  if [ -z "$(pgrep pulseaudio)" ]; then
    trace "Start pulseaudio"
    systemctl --user start pulseaudio
    sleep 1
  else
    trace "Pulseaudio is already start"
  fi
  if [ "$(cat /etc/kona/soundmode)" = "normal" ] || [ "$(cat /etc/kona/soundmode)" = "deep" ] || [ "$(cat /etc/kona/soundmode)" = "hifi" ]; then
    systemctl --user restart pulseaudio
    touch /etc/kona/restartserver
    trace "Pulseaudio is restarted"
  fi  
elif [ "$(cat /etc/kona/soundsystem)" = "pipewire" ]; then
  if [ -z "$(pgrep pipewire)" ]; then
    trace "Start pipewire"
    systemctl --user start pipewire
    sleep 1
  else
    trace "Pipewire is started"
  fi
  if [ "$(cat /etc/kona/soundmode)" = "normal" ] || [ "$(cat /etc/kona/soundmode)" = "deep" ] || [ "$(cat /etc/kona/soundmode)" = "hifi" ]; then
    systemctl --user restart pipewire
    systemctl --user restart pipewire-pulse
    touch /etc/kona/restartserver
    trace "Pipewire is restarted"
  fi  
fi
# restart mpd
#if [ ! -z "$(pgrep mpd)" ]; then
#  systemctl --user restart mpd
#fi
trace startserver-out
