#!/bin/bash
. /etc/kona/soundsystem.inc
if [ -f /etc/kona/waitime ]; then
  waitime="$(cat /etc/kona/waitime)"
else
  waitime="1.0"
fi
if [ -f /etc/kona/touchpad ]; then
  tpd="TRUE"
else
  tpd="FALSE"
fi
ret=$(yad --form --ceter --no-wrap --title="タッチパッドの設定" --image=/usr/share/icons/Adwaita/32x32/devices/input-touchpad-symbolic.symbolic.png --text="タッチパッドを設定する\n" --field="タッチパッド有効:CHK" --field="キー入力後の無効時間(秒):text" "$tpd" "$waitime")
rcd="$?"
if [ "$rcd" = "0" ]; then
  tpd="$(echo $ret|cut -d'|' -f1)"
  waitime="$(echo $ret|cut -d'|' -f2)"
  if [ "$tpd" = "TRUE" ]; then
    touch /etc/kona/touchpad
    synclient TouchpadOff=0
    synclient TapButton1=1
    synclient VertEdgeScroll=1
  else
    rm -f /etc/kona/touchpad
    synclient TouchpadOff=1
  fi
  if [ ! -z "$waitime" ]; then
    echo $waitime > /etc/kona/waitime
    killall syndaemon
    if [ "$waitime" != "0" ]; then
      syndaemon -i $waitime -K -R &
    fi
  fi
  zenity --info --title="タッチパッドの設定" --text="タッチパッドを設定しました" --no-wrap
fi

